#include "API Dialog Template.h"

HICON g_hIcon;
HINSTANCE g_hInstance;
HWND g_hWndDialog;


int APIENTRY  WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	g_hInstance = hInstance;
	InitCommonControls();
	g_hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1) );
 	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC)DialogProc);	
	DestroyIcon(g_hIcon);
	return 0;
}

INT_PTR CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	
	switch (uMsg)
	{
	case WM_COMMAND:
		if ( HIWORD(wParam) == EN_CHANGE && LOWORD(wParam) == IDC_EB_NAME )
				UpdateAllText();
		if (HIWORD(wParam) == BN_CLICKED)// On button click 
		{
			switch(LOWORD(wParam))
			{
			case IDC_OB_VC6:
			case IDC_OB_VC2003:
				UpdateAllText();
				break;
			case IDC_BTN_BFF:
				GetFolderPath(hwndDlg,GetDlgItem(hwndDlg,IDC_EB_OUT_DIR));
				break;
			case IDC_BTN_ABOUT:
				DialogBox(g_hInstance,MAKEINTRESOURCE(IDD_ABOUT),hwndDlg,(DLGPROC)AboutDlgProc);
				break;
			case IDC_BTN_CREATE:
				CreateTemplateProject();
				break;
			}
		}
		break;
	case WM_INITDIALOG:
			g_hWndDialog = hwndDlg;
			SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
			CheckDlgButton(hwndDlg,IDC_OB_VC2003,BST_CHECKED);
			return TRUE;
	case WM_CLOSE:
			EndDialog(hwndDlg,0);
			break;
	}
	return FALSE;
}
INT_PTR CALLBACK AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_COMMAND:
		if ( wParam == IDC_CMD_OK)
			EndDialog(hwndDlg,0);
			break;
	case WM_INITDIALOG:
		SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
		return true;
	case WM_CLOSE:
		EndDialog(hwndDlg,0);
		break;
	}
	return FALSE;
}

void UpdateAllText(void)
{
	char szProjectName[MAX_PATH];

	if ( GetDlgItemText(g_hWndDialog,IDC_EB_NAME,szProjectName,MAX_PATH) == NULL )
		 return;
	
	
	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_VC6) == BST_CHECKED)
	{
		CatAndSet(szProjectName,".dsp",IDC_EB_VCPROJ_DSP);
		CatAndSet(szProjectName,".dsw",IDC_EB_SLN_DSW);
	}
	else
	{
		CatAndSet(szProjectName,".vcproj",IDC_EB_VCPROJ_DSP);
		CatAndSet(szProjectName,".sln",IDC_EB_SLN_DSW);
	}

	CatAndSet(szProjectName,".h",IDC_EB_H);
	CatAndSet(szProjectName,".cpp",IDC_EB_CPP);
	
	CatAndSet(szProjectName,".rc",IDC_EB_RC);
	CatAndSet(szProjectName,".exe",IDC_EB_EXE);

	SetDlgItemText(g_hWndDialog,IDC_EB_PRJ_DIR,szProjectName);
}
void CatAndSet(LPSTR szSrc,LPSTR szCat,int iDlgItem)
{
	char szBuffer[MAX_PATH + 16];

	lstrcpy(szBuffer,szSrc);
	lstrcat(szBuffer,szCat);
	SetDlgItemText(g_hWndDialog,iDlgItem,szBuffer);
}
BOOL CreateTemplateProject(void)
{

	if (CheckEntries() == FALSE){
		MessageBox(g_hWndDialog,"Please enter project name and output folder path and try again.","Error Missing Information",MB_OK | MB_ICONWARNING);
		return FALSE;
	}
	if ( CreateOutputDir() == FALSE ){
		MessageBox(g_hWndDialog,"Error while creating new folder for project.","Error",MB_OK | MB_ICONSTOP);
		return FALSE;
	}

	CStrList sl_files;
	CStrList sl_replace;
	CStrReplaceAll sraReplace;

	MakeFilesList(&sl_files);
	MakeReplaceList(&sl_replace);
	
	if ( sraReplace.MultipleFileReplaceAll(&sl_files,&sl_replace) == FALSE){
		MessageBox(g_hWndDialog,"Unable to create new project.","Error",MB_OK | MB_ICONSTOP);
		return FALSE;
	}

	MessageBox(g_hWndDialog,"New project is generated successfully.","Success",MB_OK | MB_ICONINFORMATION);
	return TRUE;
}
BOOL CreateOutputDir(void)
{
	char szOutputDir[MAX_PATH];
	char szProjDir	[MAX_PATH];
	char szBuffer	[MAX_PATH];
	
	GetDlgItemText(g_hWndDialog,IDC_EB_OUT_DIR,szBuffer,sizeof(szBuffer));
	GetDlgItemText(g_hWndDialog,IDC_EB_PRJ_DIR,szProjDir,sizeof(szProjDir));
	
	PathCombine(szOutputDir,szBuffer,szProjDir);

	return CreateDirectory(szOutputDir,NULL);
	
}
void MakeReplaceList(CStrList * slReplace)
{
	char szBuffer	[MAX_PATH];

	GetDlgItemText(g_hWndDialog,IDC_EB_VCPROJ_DSP,szBuffer,sizeof(szBuffer));
	slReplace->AddItem("Template.vcproj",szBuffer);
	slReplace->AddItem("Template.dsp",szBuffer);

	GetDlgItemText(g_hWndDialog,IDC_EB_SLN_DSW,szBuffer,sizeof(szBuffer));
	slReplace->AddItem("Template.sln",szBuffer);
	slReplace->AddItem("Template.dsw",szBuffer);

	GetDlgItemText(g_hWndDialog,IDC_EB_H,szBuffer,sizeof(szBuffer));
	slReplace->AddItem("Template.h",szBuffer);

	GetDlgItemText(g_hWndDialog,IDC_EB_CPP,szBuffer,sizeof(szBuffer));
	slReplace->AddItem("Template.cpp",szBuffer);

	GetDlgItemText(g_hWndDialog,IDC_EB_RC,szBuffer,sizeof(szBuffer));
	slReplace->AddItem("Template.rc",szBuffer);

	GetDlgItemText(g_hWndDialog,IDC_EB_EXE,szBuffer,sizeof(szBuffer));
	slReplace->AddItem("Template.exe",szBuffer);

	GetDlgItemText(g_hWndDialog,IDC_EB_NAME,szBuffer,sizeof(szBuffer));
	slReplace->AddItem("%prj_template%",szBuffer);
}
void MakeFilesList(CStrList * slFiles)
{
	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_VC6) == BST_CHECKED)
	{
		AddFileItem(slFiles,IDC_EB_VCPROJ_DSP,"Template.dsp");
		AddFileItem(slFiles,IDC_EB_SLN_DSW,"Template.dsw");
	}
	else
	{
		AddFileItem(slFiles,IDC_EB_VCPROJ_DSP,"Template.vcproj");
		AddFileItem(slFiles,IDC_EB_SLN_DSW,"Template.sln");
	}

	AddFileItem(slFiles,IDC_EB_H,"Template.h");
	AddFileItem(slFiles,IDC_EB_CPP,"Template.cpp");
	AddFileItem(slFiles,IDC_EB_RC,"Template.rc");

	AddFileItem(slFiles,"manifest.manifest","manifest.manifest");
	AddFileItem(slFiles,"resource.h","resource.h");
}
void AddFileItem(CStrList * slFileList,int iDlgItemId,LPSTR szSourceFile)
{
	char szBuffer	[MAX_PATH];
	GetDlgItemText(g_hWndDialog,iDlgItemId,szBuffer,sizeof(szBuffer));
	AddFileItem(slFileList,szSourceFile,szBuffer);
}
void AddFileItem(CStrList * slFileList,LPSTR szSourceFile,LPSTR szOutputFile)
{
	char szSourceDir[MAX_PATH];
	char szOutputDir[MAX_PATH];
	char szProjDir	[MAX_PATH];
	char szBuffer	[MAX_PATH];
	char szSrcPath	[MAX_PATH];
	char szOutPath	[MAX_PATH];

	// For getting source Folder path -> first get this executable path then strip file name 
	// to get folder path and then combine template Folder name.
	GetModuleFileName(NULL,szBuffer,sizeof(szBuffer));
	PathRemoveFileSpec(szBuffer);
	PathCombine(szSourceDir,szBuffer,STR_TEMPLATE_DIR);

	// Get destination folder path from text box.
	GetDlgItemText(g_hWndDialog,IDC_EB_OUT_DIR,szOutputDir,sizeof(szOutputDir));
	GetDlgItemText(g_hWndDialog,IDC_EB_PRJ_DIR,szProjDir,sizeof(szProjDir));
	
	PathCombine(szBuffer,szOutputDir,szProjDir);
	lstrcpy(szOutputDir,szBuffer);
	PathCombine(szOutPath,szOutputDir,szOutputFile);

	PathCombine(szSrcPath,szSourceDir,szSourceFile);
	slFileList->AddItem(szSrcPath,szOutPath);
}
BOOL CheckEntries(void)
{
		if (GetTextLen(IDC_EB_NAME) < 1)
			return FALSE;
		if (GetTextLen(IDC_EB_VCPROJ_DSP) < 1)
			return FALSE;
		if (GetTextLen(IDC_EB_SLN_DSW) < 1)
			return FALSE;
		if (GetTextLen(IDC_EB_H) < 1)
			return FALSE;
		if (GetTextLen(IDC_EB_CPP) < 1)
			return FALSE;
		if (GetTextLen(IDC_EB_RC) < 1)
			return FALSE;
		if (GetTextLen(IDC_EB_EXE) < 1)
			return FALSE;
		if (GetTextLen(IDC_EB_PRJ_DIR) < 1)
			return FALSE;
		if (GetTextLen(IDC_EB_OUT_DIR) < 1)
			return FALSE;

	return TRUE;
}

int GetTextLen(int iDlgItemID)
{
return GetWindowTextLength(GetDlgItem(g_hWndDialog,iDlgItemID));
}
/* 
int GetDlgTextLen(HWND hwndDlg,int iDlgItemID)
{
return GetWindowTextLength(GetDlgItem(hwndDlg,iDlgItemID));
}
*/
/*
This software created by Muhammad Arshad Latti
From Sargodha ( Pakistan) 
e-mail   :: arshadlatti@gmail.com 
web_site :: http://www.geocities.com/arshadlati
*/