#include "CStrReplaceAll.h"
/*
CStrReplaceAll::CStrReplaceAll()
{
	return;
}

CStrReplaceAll::~CStrReplaceAll()
{
	return;
}
*/
BOOL CStrReplaceAll::MultipleFileReplaceAll(CStrList * slFiles,CStrList * slReplace)
{
	for(int i=0; i < slFiles->Count();i++)
	{
		if (!FileStringReplaceAll(slFiles->GetItemKey(i),slFiles->GetItemData(i),slReplace))
				return FALSE;
	}
	return TRUE;
}
BOOL CStrReplaceAll::FileStringReplaceAll(LPSTR szSrcFilePath,LPSTR szNewFilePath,CStrList * slReplace)
{
	if (slReplace->Count() == 0)
		return FALSE;

	HANDLE hf_src = OpenFileForRead(szSrcFilePath);
	if (hf_src==INVALID_HANDLE_VALUE)
			return FALSE;

	HANDLE hf_new = OpenFileForWrite(szNewFilePath);
	if (hf_new==INVALID_HANDLE_VALUE){
			CloseHandle(hf_src);
			return FALSE;
	}

	LPSTR lpReadBuffer = ReadFile2Buffer(hf_src);
	if(!lpReadBuffer){
			CloseHandle(hf_src);
			CloseHandle(hf_new);
			return FALSE;
	}

	int nCount , nFind , nReplace,nBuffer,nValue;
	LPSTR szOutBuffer;
	for (int i = 0; i < slReplace->Count();i++)
	{
		nCount	    = StringFindAndCount(lpReadBuffer,slReplace->GetItemKey(i));
		if (!nCount)
			  continue;

		nFind		= lstrlen(slReplace->GetItemKey(i));
		nReplace	= lstrlen(slReplace->GetItemData(i));
		nBuffer		= lstrlen(lpReadBuffer);

		nValue		= nFind * nCount;
		nValue		= nBuffer - nValue;
		nValue		= (nReplace * nCount) + nValue;
		nValue++;
		try	{
		szOutBuffer = new char[nValue];
			if (!szOutBuffer){
			CloseHandle(hf_src);
			CloseHandle(hf_new);
			delete [] lpReadBuffer;
			return FALSE;
			}
		}
		catch(...){
			CloseHandle(hf_src);
			CloseHandle(hf_new);
			delete [] lpReadBuffer;
			return FALSE;
		}
		
		TextReplaceAll(szOutBuffer,lpReadBuffer,slReplace->GetItemKey(i),slReplace->GetItemData(i));
		delete [] lpReadBuffer;
		lpReadBuffer = szOutBuffer;
	}
	
	if (WriteBuffer2File(hf_new,lpReadBuffer))
	{
			CloseHandle(hf_src);
			CloseHandle(hf_new);
			delete [] lpReadBuffer;
			return TRUE;
	}
			CloseHandle(hf_src);
			CloseHandle(hf_new);
			delete [] lpReadBuffer;
			return FALSE;
}

HANDLE CStrReplaceAll::OpenFileForWrite(LPSTR szFileName)
{
 return CreateFile(szFileName,
		GENERIC_WRITE,FILE_SHARE_READ,NULL,
		CREATE_NEW,FILE_ATTRIBUTE_NORMAL,
		NULL);
}
HANDLE CStrReplaceAll::OpenFileForRead(LPSTR szFileName)
{
	return CreateFile(szFileName,
		GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,
		NULL);
}
LPSTR CStrReplaceAll::ReadFile2Buffer(HANDLE hFile)
{
	DWORD nRead , nFileSize;
	BOOL bRet;
	LPSTR lpBuffer;

	nFileSize = GetFileSize(hFile,NULL);

	try	{
		lpBuffer = new char[nFileSize +  1];
			if (!lpBuffer)
					return NULL;
		}
		catch(...){
		return NULL;
	}

	bRet = ReadFile(hFile,lpBuffer,nFileSize,&nRead,NULL);

	if (nRead == nFileSize	&& bRet	!= NULL)
	{
		lpBuffer[nFileSize] = 0;
		return lpBuffer;
	}
	
	delete [] lpBuffer;
	return NULL;
}

BOOL CStrReplaceAll::WriteBuffer2File(HANDLE hFile,LPSTR szString)
{
	DWORD nWritten;
	BOOL bRet;
	DWORD ccString = lstrlen(szString);

	bRet = WriteFile(hFile,szString,ccString,&nWritten,NULL);
     
	if (nWritten == ccString && bRet != FALSE)
		return TRUE;

	return FALSE;
}

BOOL CStrReplaceAll::TextReplaceAll(LPSTR szOut,LPSTR szSrc,LPSTR szFind,LPSTR szReplace)
{
	int iLastMatch = 1;
	int iCurFind   = 0;
	int ccSrc    = lstrlen(szSrc);
	int ccFind   = lstrlen(szFind);
	int iFindLoc = FindString(szSrc,szFind,iLastMatch -1);
	
	szOut[0] = 0;

	while (iFindLoc)
	{
		iCurFind = iFindLoc  - iLastMatch;
		if(iCurFind)
			strncat(szOut,&szSrc[iLastMatch - 1],iCurFind);
	
		lstrcat(szOut,szReplace);
		iLastMatch = iFindLoc + ccFind;
		iFindLoc  = FindString(szSrc,szFind,iLastMatch - 1);
	}
	
	if ( iLastMatch == 1)
	{
		lstrcpy(szOut,szSrc);
		return TRUE;
	}
	if ( iLastMatch == ccSrc)
		strncat(szOut,&szSrc[iLastMatch - 1],1);


	if ( iLastMatch < ccSrc )
	{
			iLastMatch--;
			strncat(szOut,&szSrc[iLastMatch],ccSrc - iLastMatch);
	}
	return TRUE;	
}

int CStrReplaceAll::FindString(LPSTR szSrc,LPSTR szFind,int iStartLoc)
{
	int nMatch	= 0;
	int ccFind  = lstrlen(szFind);
	int ccSrc	= lstrlen(szSrc);

	for (int i = iStartLoc;i < ccSrc;i++)
	{
		if (szSrc[i] == szFind[nMatch])
				nMatch++;
		else
				nMatch = 0;
		if (nMatch == ccFind)
				return (i + 2) - ccFind;			
	}
	return NULL;
}

int CStrReplaceAll::StringFindAndCount(LPSTR szSource,LPSTR szFind)
{
	int iCount	= 0;
	int nMatch	= 0;
	int ccFind  = lstrlen(szFind);
	int ccSrc	= lstrlen(szSource);

	for (int i = 0;i < ccSrc;i++)
	{
		if (szSource[i] == szFind[nMatch])
				nMatch++;
		else
				nMatch = 0;
		if (nMatch == ccFind)
		{
			nMatch = 0;
			iCount++;
		}
				
	}

	return iCount;
}
// A project by Muhammad Arshad Latti